﻿
using UnityEngine;
using System.Collections;

public class Horse : MonoBehaviour
{	
	private Animator anim;
	public bool footDown;
	public string leftKey;
	public string rightKey;
	public int timeout = 10;

	private bool started = false;

	// Use this for initialization
	void Start ()
	{
		anim = gameObject.GetComponent<Animator> ();
		anim.speed = 0f;
	}
	
	// Update is called once per frame
	void Update ()
	{
		
		//check for the race start key, which is spacebar
		if (Input.GetKeyDown ("space")) {
			started = true;
		}


		if (started) {

			if (Input.GetKeyDown (leftKey)) {			
				processFoot (true); 
			}

			if (Input.GetKeyDown (rightKey)) {			
				processFoot (false); 
			}
				
			timeout--;

			if (timeout < 0) {
				anim.speed = 0f;
			}
		}

	}

	void processFoot(bool down) {
		
		if (down && !footDown) {

			timeout = 20;

			anim.Play ("HorseRun");
			anim.speed = 1f;

			footDown = true;

			transform.position += Vector3.right * 10f * Time.deltaTime;

		} else if(!down && footDown) {
			footDown = false;
			timeout = 20;
			//anim.speed = 0f;
		}
	}
}

