﻿using UnityEngine;
using System.Collections;
using System;
using UnityEngine.UI;

public class Main : MonoBehaviour
{
	bool winner = false;
	ArrayList rankings = new ArrayList();
	ArrayList times = new ArrayList();


	bool started = false;

	// Use this for initialization
	void Start ()
	{
		resetGame ();
	}
	
	// Update is called once per frame
	void Update ()
	{
		if (started) {
			//keep checking till all are done
			if (rankings.Count < 8) {
				//check the horse positions for winner
				for (var i = 0; i < 8; i++) {
					checkComplete (i);
				}
			} else {
				//race has completed
				completeRace();
			}
		}

		handleKeys ();
	}

	void resetGame() {

		GameObject logo = GameObject.Find ("LogoImage");
		logo.GetComponent<Renderer>().enabled = true;

		for (int i = 0; i < 8; i++) {
			GameObject h = GameObject.Find ("Horse" + i.ToString ());

			h.transform.position = new Vector3 (-8.22f, h.transform.position.y, h.transform.position.z);
		}

		GameObject score = GameObject.Find ("FinalScores");
		score.GetComponent<Renderer>().enabled = false;

		GameObject final = GameObject.Find ("Final");
		final.GetComponent<Canvas>().enabled = false;
			
		GameObject timer = GameObject.Find ("Timer");
		timer.GetComponent<Text> ().text = "00:00:00";

		//reset the time
		started = false;

	}

	void checkComplete(int x) {

		GameObject h = GameObject.Find ("Horse" + x.ToString());
		if (h.transform.transform.position.x > 8) {
			winner = true;

			if (!rankings.Contains (x)) {
				rankings.Add (x);

				GameObject timer = GameObject.Find ("Timer");
				times.Add (timer.GetComponent<Text>().text);
			}
		}
	}

	void completeRace() {
		started = false;
			
		//show the scores

		//set the scores
		for(int i = 0; i < rankings.Count; i++) {
			GameObject rank = GameObject.Find ("Place" + i);

			string r = string.Empty;

			switch((int) rankings[i]) {

				case 0: {
					r = "1st";
					break;
				}
				case 1: {
					r = "2nd";
						break;
					}
				case 2: {
					r = "3rd";
						break;
					}
				case 3: {
					r = "4th";
						break;
					}
				case 4: {
					r = "5th";
						break;
					}
				case 5: {
					r = "6th";
						break;
					}
				case 6: {
					r = "7th";
						break;
					}
				case 7: {
					r = "8th";
						break;
				}
			}
				
			rank.GetComponent<Text>().text = r;

			GameObject ss = GameObject.Find ("Score" + i);

			ss.GetComponent<Text> ().text = times [i].ToString ();

		}

		//add did not complete

		for(int i = 0; i < 8; i++) {
			if(!rankings.Contains(i)) {
				GameObject rank = GameObject.Find ("Place" + i);

				rank.GetComponent<Text>().text = "No Finish";
			}
		}

		GameObject score = GameObject.Find ("FinalScores");
		score.GetComponent<Renderer>().enabled = true;

		GameObject final = GameObject.Find ("Final");
		final.GetComponent<Canvas>().enabled = true;

	}

	void startRace() {
		
		started = true;

	
	}

	//process all key presses
	void handleKeys() {

		//start the game screen
		if (Input.GetKeyDown ("return")) {
			GameObject logo = GameObject.Find ("LogoImage");
			logo.GetComponent<Renderer>().enabled = false;
		}

		//check for the race start key, which is spacebar
		if (!started && Input.GetKeyDown ("space")) {
			startRace ();
		}

		//reset the race
		if( Input.GetKeyDown("=")) {
			resetGame ();
		}

		//oh shit key race wont ever finish
		//so lets tally up now
		if (Input.GetKeyDown ("escape")) {
			completeRace ();
		}


	}
}

